/****************************************************************************************
*  YAROCK                                                                               *
*  Copyright (c) 2010-2013 Sebastien amardeilh <sebastien.amardeilh+yarock@gmail.com>   *
*                                                                                       *
*  This program is free software; you can redistribute it and/or modify it under        *
*  the terms of the GNU General Public License as published by the Free Software        *
*  Foundation; either version 2 of the License, or (at your option) any later           *
*  version.                                                                             *
*                                                                                       *
*  This program is distributed in the hope that it will be useful, but WITHOUT ANY      *
*  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A      *
*  PARTICULAR PURPOSE. See the GNU General Public License for more details.             *
*                                                                                       *
*  You should have received a copy of the GNU General Public License along with         *
*  this program.  If not, see <http://www.gnu.org/licenses/>.                           *
*****************************************************************************************/

#ifndef _INFO_PROVIDER_H_
#define _INFO_PROVIDER_H_

#include <QString>


#include "MediaItem/mediaitem.h"

/*
********************************************************************************
*                                                                              *
*    Class InfoProvider                                                        *
*                                                                              *
********************************************************************************
*/
class InfoProvider
{
  public:
    InfoProvider(const QString& name);

    QString name() const { return m_name; }
    void set_name(const QString& n) { m_name = n; }

    bool is_enabled() const { return m_enabled; }
    void set_enabled(bool enabled) { m_enabled = enabled; }

    void set_media(MEDIA::TrackPtr media) {m_current_media = media;}

    virtual void cancel_searches() {};
    virtual void init() {};
    virtual void fetch_info(int id) = 0;

  public:
    MEDIA::TrackPtr      m_current_media;

  private :
    bool              m_enabled;
    QString           m_name;
};

#endif // _INFO_PROVIDER_H_
