/****************************************************************************************
*  YAROCK                                                                               *
*  Copyright (c) 2010-2013 Sebastien amardeilh <sebastien.amardeilh+yarock@gmail.com>   *
*                                                                                       *
*  This program is free software; you can redistribute it and/or modify it under        *
*  the terms of the GNU General Public License as published by the Free Software        *
*  Foundation; either version 2 of the License, or (at your option) any later           *
*  version.                                                                             *
*                                                                                       *
*  This program is distributed in the hope that it will be useful, but WITHOUT ANY      *
*  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A      *
*  PARTICULAR PURPOSE. See the GNU General Public License for more details.             *
*                                                                                       *
*  You should have received a copy of the GNU General Public License along with         *
*  this program.  If not, see <http://www.gnu.org/licenses/>.                           *
*****************************************************************************************/

#ifndef _SERVICE_ICECAST_H_
#define _SERVICE_ICECAST_H_

#include "service_base.h"
#include "MediaItem/mediaitem.h"

#include <QList>
#include <QByteArray>
#include <QObject>
/*
********************************************************************************
*                                                                              *
*    Class IceCast                                                             *
*                                                                              *
********************************************************************************
*/
class IceCast : public Service
{
Q_OBJECT
public:
    IceCast();
    virtual void load();
    virtual void reload();
    virtual QList<MEDIA::TrackPtr> streams();
    
private slots:
    void slot_send_request();
    void slot_parse_response(QByteArray);
    void slot_error();
    
private:
    QList<MEDIA::TrackPtr>    m_streams;
};

#endif // _SERVICE_ICECAST_H_
